package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.io.File;

/**
 *  A class to contain parameters that are common to implementations 
 *  of ScanSaveType.  Normally, this would be done by making ScanSaveType
 *  an abstract class containing this stuff.  But, rather it was done as
 *  a separate class to better enable an XML wrapper.
 */
public class CommonScanSaveParams {
    public final String filenameSuffix;
    public final String filenameExtension;
    public final File outputDirectory;

    public CommonScanSaveParams(String filenameSuffix,
            String filenameExtension, File outputDirectory) {
        this.filenameSuffix = filenameSuffix;
        this.filenameExtension = filenameExtension;
        this.outputDirectory = outputDirectory;
    }

    public CommonScanSaveParams(String filenameSuffix,
            String filenameExtension) {
        this(filenameSuffix, filenameExtension, 
                new File(System.getProperty("user.dir")));
    }

}
