package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.awt.image.WritableRaster;

import javax.media.jai.TiledImage;

/**
 *  Encapsulates the image for a "CYBERTORY.ORG" marker to be placed in the
 *  upper left corner of the microarray image scan.
 */
public class CybertoryMark {

    static final int width = 67;
    static final int height = 7;
    static public TiledImage image;

    static {
        image = new TiledImage(0, 0, width, height, 0, 0, 
                new FloatSampleModel(width,height,1), null);

        WritableRaster raster = image.getWritableTile(0,0);

        int[][] watermarkCoords = new int[][] {
        {2, 1}, {3, 1}, {4, 1}, {6, 1}, {10, 1}, {12, 1}, {13, 1}, {14, 1},
        {17, 1}, {18, 1}, {19, 1}, {20, 1}, {22, 1}, {23, 1}, {24, 1}, {27, 1},
        {28, 1}, {29, 1}, {30, 1}, {31, 1}, {34, 1}, {35, 1}, {38, 1}, {39, 1},
        {40, 1}, {43, 1}, {47, 1}, {52, 1}, {53, 1}, {56, 1}, {57, 1}, {58, 1},
        {63, 1}, {64, 1}, {65, 1},
        {1, 2}, {7, 2}, {9, 2}, {12, 2}, {15, 2}, {17, 2}, {22, 2}, {25, 2},
        {29, 2}, {33, 2}, {36, 2}, {38, 2}, {41, 2}, {44, 2}, {46, 2}, {51, 2},
        {54, 2}, {56, 2}, {59, 2}, {62, 2},
        {1, 3}, {8, 3}, {12, 3}, {13, 3}, {14, 3}, {17, 3}, {18, 3}, {19, 3},
        {22, 3}, {23, 3}, {24, 3}, {29, 3}, {33, 3}, {36, 3}, {38, 3}, {39, 3},
        {40, 3}, {45, 3}, {51, 3}, {54, 3}, {56, 3}, {57, 3}, {58, 3}, {62, 3},
        {64, 3}, {65, 3},
        {1, 4}, {8, 4}, {12, 4}, {15, 4}, {17, 4}, {22, 4}, {24, 4}, {29, 4},
        {33, 4}, {36, 4}, {38, 4}, {40, 4}, {45, 4}, {51, 4}, {54, 4}, {56, 4},
        {59, 4}, {62, 4}, {65, 4},
        {2, 5}, {3, 5}, {4, 5}, {8, 5}, {12, 5}, {13, 5}, {14, 5}, {17, 5},
        {18, 5}, {19, 5}, {20, 5}, {22, 5}, {25, 5}, {29, 5}, {34, 5}, {35, 5},
        {38, 5}, {41, 5}, {45, 5}, {49, 5}, {52, 5}, {53, 5}, {56, 5}, {60, 5},
        {63, 5}, {64, 5}, {65, 5}
        };

        for (int i=0; i<watermarkCoords.length; ++i) {
            int[] coords = watermarkCoords[i];
            raster.setSample(coords[0], coords[1], 0, 1f);
        }

        image.releaseWritableTile(0, 0);
    }

}
