package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.awt.Shape;
import java.awt.geom.Point2D;

/** 
 *  This interface is for classes that determine the shape of a feature on
 *  the image, given the location of the center of the feature.
 */
public interface FeatureShapeFactory {

    /**
     * Generates a shape for the feature at the given location.
     * @param featurePixelSize  pixel size of feature
     * @param featureCenter the location of the center of the feature 
     *                      in pixel coordinates
     * @return a {@link java.awt.Shape} object 
     */
    public Shape createFeatureShape(float featurePixelSize,
            Point2D featureCenter);

}
