package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.awt.Shape;
import java.awt.image.RenderedImage;

import javax.media.jai.ImageLayout;

/**
 * A means of altering the default uniform filling in of features.
 * The {@link #createTexture} returns an image that is to be multiplied by
 * uniform intensities to produce non-uniform intensities.  Be aware that
 * means any pixels not to be altered in the result must have a pixel value
 * of 1.0 in the returned image.  Holes/gaps in the feature can be created
 * with pixel values of 0.0.
 * The image produced must match the passed in {@link ImageLayout} object.
 */
public interface FeatureTexture {

    public RenderedImage createTexture(Shape featureShape, int numChannels);

}
