package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.awt.Shape;
import java.awt.geom.Rectangle2D;
import java.awt.image.RenderedImage;
import java.awt.image.renderable.ParameterBlock;

import javax.media.jai.JAI;

/**
 *  An implementation of FeatureTexture that wraps a constant image.
 */
public class FeatureTextureConst implements FeatureTexture {

    private final RenderedImage image;


    public FeatureTextureConst(RenderedImage image) {
        this.image = image;
        float inWidth = image.getWidth();
        float inHeight = image.getHeight();
    }


    public RenderedImage createTexture(Shape featureShape, int numChannels) {
        Rectangle2D bounds = featureShape.getBounds2D();
        float widthMultiple =
                (float)bounds.getWidth() / (float)image.getWidth();
        float heightMultiple =
                (float)bounds.getHeight() / (float)image.getHeight();

        ParameterBlock pb = new ParameterBlock();
        pb.addSource(image);
        pb.add(widthMultiple);
        pb.add(heightMultiple);
        pb.add((float)bounds.getMinX());
        pb.add((float)bounds.getMinY());

        return JAI.create("scale", pb);
    }

}
