package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.awt.Shape;
import java.awt.geom.Rectangle2D;
import java.awt.image.RenderedImage;
import java.awt.image.renderable.ParameterBlock;

import javax.media.jai.ImageFunction;
import javax.media.jai.JAI;

/**
 *  A FeatureTexture that is derived from an
 *  {@link javax.media.jai.ImageFunction} object.
 */
public class FeatureTextureFunction implements FeatureTexture {

    private final ImageFunction iFunction;
    private final float scale;


    public FeatureTextureFunction(ImageFunction iFunction) {
        this(iFunction, 1f);
    }


    public FeatureTextureFunction(ImageFunction iFunction, float scale) {
        this.iFunction = iFunction;
        this.scale = scale;
    }


    public RenderedImage createTexture(Shape featureShape, int numChannels) {
        Rectangle2D bounds = featureShape.getBounds2D();

        ParameterBlock pb = new ParameterBlock();
        pb.add(iFunction);
        pb.add((float)bounds.getWidth());
        pb.add((float)bounds.getHeight());
        pb.add(scale);
        pb.add(scale);
        pb.add(bounds.getMinX());
        pb.add(bounds.getMinY());
        return JAI.create("imagefunction", pb);
    }

}
