package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
/**
 * This class encapsulates general features specifications.
 */
public class FeaturesSpecs implements SelfScaler {

    public final float featureSize;
    public final float featureCellSizeX;
    public final float featureCellSizeY;
    public final FeatureShapeFactory defaultShapeFactory;
    public final FeatureTexture defaultTexture;


    public FeaturesSpecs(
            float featureSize,
            float featureCellSizeX,
            float featureCellSizeY,
            FeatureShapeFactory defaultShapeFactory,
            FeatureTexture defaultTexture)  {

        this.featureSize = featureSize;
        this.featureCellSizeX = featureCellSizeX;
        this.featureCellSizeY = featureCellSizeY;
        this.defaultShapeFactory = defaultShapeFactory;
        this.defaultTexture = defaultTexture;
    }


    public Object getScaled(float pixelSize) {
        return new FeaturesSpecs(
            featureSize/pixelSize,
            featureCellSizeX/pixelSize,
            featureCellSizeY/pixelSize,
            defaultShapeFactory,
            defaultTexture);
    }

}
