package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.awt.RenderingHints;
import java.awt.image.DataBuffer;
import java.awt.image.PixelInterleavedSampleModel;
import java.awt.image.SampleModel;

import javax.media.jai.ImageLayout;
import javax.media.jai.JAI;

/**
 *  A {@link java.awt.image.SampleModel} implementation for float pixels.
 */
public class FloatSampleModel extends PixelInterleavedSampleModel {

    public FloatSampleModel(int imageWidth, int imageHeight, int numChannels) {
        super(DataBuffer.TYPE_FLOAT, imageWidth, imageHeight, numChannels,
              numChannels * imageWidth, genBandOffsets(numChannels));
    }


    static private int[] genBandOffsets(int numChannels) {
        int[] offsets = new int[numChannels];
        for (int i=0; i<numChannels; ++i) {
            offsets[i] = i;
        }
        return offsets;
    }


    static public RenderingHints getRenderingHints(int minX, int minY,
            int imageWidth, int imageHeight, int numChannels) {

        SampleModel sm =
                new FloatSampleModel(imageWidth, imageHeight, numChannels);

        ImageLayout il = new ImageLayout(minX, minY, imageWidth, imageHeight);
        il.setSampleModel(sm);
        return new RenderingHints(JAI.KEY_IMAGE_LAYOUT, il);
    }

}
