package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.awt.image.renderable.ParameterBlock;

import javax.media.jai.JAI;
import javax.media.jai.RenderedOp;

/**
 *  An image file format that stores all channels as floats in one file.
 */
public class FloatTiff extends ScanSaveType {

    static public final String defaultFilenameExtension = "tif";


    public FloatTiff(CommonScanSaveParams commonParams) {
        super(commonParams);
    }


    public void createFile(RenderedOp image, String fileStem) {
        ParameterBlock pb = new ParameterBlock();
        pb.addSource(image);
        pb.add(imagePath(fileStem, ""));
        pb.add("tiff");
        pb.add(null);
        JAI.create("FileStore", pb);
    }

}
