package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

import javax.media.jai.ImageFunction;

/** 
 * A class for {@link ImageFunction} implementations that are
 * instantiated using a no-parameter constructor.
 */
public class IFunctionFromName implements ImageFunction {

    private ImageFunction function;

    public IFunctionFromName(String className) throws
            ClassNotFoundException, InvocationTargetException,
            NoSuchMethodException, InstantiationException,
            IllegalAccessException {

        Class cls = Class.forName(className); 
        Constructor constr = cls.getConstructor(new Class[] {});
        function = (ImageFunction) constr.newInstance(new Object[] {});
    }


    public void getElements(
            double startX, double startY,
            double deltaX, double deltaY,
            int countX, int countY,
            int element, double[] real, double[] imag) {

        function.getElements(startX, startY, deltaX, deltaY,
                countX, countY, element, real, imag);
    }


    public void getElements(
            float startX, float startY,
            float deltaX, float deltaY,
            int countX, int countY,
            int element, float[] real, float[] imag) {

        function.getElements(startX, startY, deltaX, deltaY,
                countX, countY, element, real, imag);
    }


    public int getNumElements() {
        return function.getNumElements();
    }


    public boolean isComplex() {
        return function.isComplex();
    }
    
}
