package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.util.Vector;
import org.jdom.Document;

/** 
 *  Microarray scan simulation (Image Generator class)
 */
public class ImagesRequest {

    private Document xmlDoc;
    private Vector dataFactories = new Vector();


    public ImagesRequest(Document xmlDoc) {
        this.xmlDoc = xmlDoc;
    }


    public void addExternalDataFactory(ExternalDataFactory edf) {
        dataFactories.add(edf);
    }


    public void generateImages() {

        try {
            ExternalDataFactory[] factories = (ExternalDataFactory[])
                    dataFactories.toArray( 
                            new ExternalDataFactory[dataFactories.size()]);

            Scan[] scans = XMLHandler.parseXMLDocument(xmlDoc, factories);
            for (int i=0; i<scans.length; ++i) {
                scans[i].saveImages();
            }
        }
        catch (XMLParseException e) {
            System.out.println(e);
            e.printStackTrace();
            Throwable t = e.getCause();
            if (t != null) {
            	t.printStackTrace();
            }
            throw new RuntimeException();
        }
        catch (Exception e) {
            System.out.println(e);
            e.printStackTrace();
                throw new RuntimeException();
        }

    }

}
