package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.awt.geom.Point2D;

/**
 *  An interface for classes to specify the size of the microarray image and
 *  the locations of the zones.
 */
public interface MaLayout extends SelfScaler {

    /** Returns image width in pixels */
    public float getWidth();
    /** Returns image height in pixels */
    public float getHeight();

    public MaDimensions getDimensions();

    /**
     *  Get the location of a zone, given the index.
     *
     * @param zoneIndex the zero-based index of the zone of interest.
     * @return {@link Point2D} object with the pixel coordinates of the
     *    upper-left corner of the zone.
     */
    public Point2D getZoneLocation(int zoneIndex);
}
