package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.io.File;
import java.io.FileFilter;
import java.util.regex.Pattern;


public class PatternFileFilter implements FileFilter {

    private final String patternStr;


    public PatternFileFilter(String[] extensions) {
        this(genPattern(extensions));
    }


    public PatternFileFilter(String patternStr) {
        this.patternStr = patternStr;
    }
    

    public boolean accept(File f) {
        return Pattern.matches(patternStr, f.getName());
    }


    static private String genPattern(String[] extensions) {
        StringBuffer buf = new StringBuffer(".*\\.(" + extensions[0]);
        for (int i=1; i<extensions.length; ++i) {
            buf.append('|' + extensions[i]);
        }
        buf.append(")\\z");
        return buf.toString();
    }

}
