package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.awt.geom.Point2D;

/** A struct-like class for holding polar coordinates. */

class PolarCoords {
    final float angle;
    final float radius;

    PolarCoords(float angle, float radius) {
        this.angle = angle;
        this.radius = radius;
    }

    Point2D getCartesian() {
        return new Point2D.Float(radius * (float)Math.cos(angle),
                                 radius * (float)Math.sin(angle));
    }

}
