package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.lang.Math;
import java.util.Random;

/**
 *  Describes a term in a noise polynomial, used in
 *  {@link PolynomialNoiseFunction}.
 */
public class PolynomialNoiseTerm {

    private final float exponent;
    private final float stddev;

    public PolynomialNoiseTerm(float exponent, float stddev) {
        this.exponent = exponent;
        this.stddev = stddev;
    }


    public float calc(float srcValue, Random rand) {
        return (float)( Math.pow((double)srcValue, (double)exponent) *
                rand.nextGaussian() * (double)stddev );
    }

}
