package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.util.HashMap;

/**
 *  Base class for a series of classes to change arrays from 
 *  objects to primitive types.
 */
public abstract class PrimitiveArrayer {

    static HashMap typeMap = new HashMap();
    static {
        typeMap.put(float.class, new FloatArrayer());
        typeMap.put(boolean.class, new BooleanArrayer());
        typeMap.put(int.class, new IntArrayer());
        typeMap.put(double.class, new DoubleArrayer());
        typeMap.put(byte.class, new ByteArrayer());
        typeMap.put(long.class, new LongArrayer());
        typeMap.put(short.class, new ShortArrayer());
    }


    abstract public Object genArray(Object[] parsedItems);

    static public PrimitiveArrayer getArrayer(Class pClass) {
        return (PrimitiveArrayer)typeMap.get(pClass);
    }
}
