package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
/**
 * The top class in the hierarchy of data describing a
 * simulated microarray scan.
 */
public class Scan {

    private final PendingRenderedOp microarray;
    private final Scanner scanner;
    private final String fileStem;
    private final float gain;

    public Scan(PendingRenderedOp microarray, Scanner scanner, String fileStem, 
            float gain) {
        this.microarray = microarray;
        this.scanner = scanner;
        this.fileStem = fileStem;
        this.gain = gain;
    }


    public void saveImages() {
        scanner.saveImages(microarray, fileStem, gain);
    }

}
