package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.io.File;

import javax.media.jai.RenderedOp;

/**
 * Base class for image file save type.
 */
public abstract class ScanSaveType {

    public final CommonScanSaveParams commonParams;

    protected ScanSaveType(CommonScanSaveParams commonParams) {
        this.commonParams = commonParams;
    }


    public abstract void createFile(RenderedOp image, String fileStem);


    public String imagePath(String fileStem) {
        return imagePath(fileStem, "");
    }


    public String imagePath(String fileStem, String suffix) {
        File dir = commonParams.outputDirectory;
        if (dir == null) {
            dir = new File(System.getProperty("user.dir"));
        }
        String totalSuffix = ((commonParams.filenameSuffix != null) ?
                commonParams.filenameSuffix : "") + suffix;

        String fName = fileStem + totalSuffix + "." +
                commonParams.filenameExtension;
        File imageFile = new File(dir, fName);
        return imageFile.getPath();
    }

}
