package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import javax.media.jai.ImageFunction;

public abstract class SimpleFunction implements ImageFunction {

    public void getElements(
            double startX, double startY, 
            double deltaX, double deltaY, 
            int countX, int countY, 
            int element, double[] real, double[] imag) {
        double x,y;

        for (int i=0; i<countX; ++i) {
            x = startX + deltaX * (double)i;
            for (int j=0; j<countY; ++j) {
                y = startY + deltaY * (double)j;
                real[j*countX+i] = calcValue(x,y);
            }
        }
    }


    public void getElements(
            float startX, float startY, 
            float deltaX, float deltaY, 
            int countX, int countY, 
            int element, float[] real, float[] imag) {
        float x,y;

        for (int i=0; i<countX; ++i) {
            x = startX + deltaX * (float)i;
            for (int j=0; j<countY; ++j) {
                y = startY + deltaY * (float)j;
                real[j*countX+i] = (float)calcValue(x,y);
            }
        }
    }


    public int getNumElements() {
        return 1;
    }


    public boolean isComplex() {
        return false;
    }


    public abstract double calcValue(double x, double y);

}
