package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.awt.geom.Point2D;

/**
 *  A SpotterTip encapsulates tip effects for a zone.  These effects can
 *  include the location of the spot relative to the center of the feature cell
 *  and/or the texture effects of the actual tip.
 *
 *  Possible causes of deviation of the spot from the center of the cell
 *  include a bent spotting tip or a wobble (random movement while spotting)
 *  of the tip.  The center of the tip as calculated here would be passed
 *  to the FeatureShapeFactory to guide its position.
 */

public interface SpotterTip extends SelfScaler {
    public SpotterTipContact getSpotterTipContact(Point2D featureCellCenter,
            float featureSize);
}
