package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.awt.geom.Point2D;
import java.awt.image.renderable.ParameterBlock;
import java.util.Random;

import javax.media.jai.ImageFunction;
import javax.media.jai.JAI;
import javax.media.jai.RenderedOp;

/**
 *  An implementation of {@link SpotterTip} that uses an {@link ImageFunction}.
 */
public class SpotterTipFunction implements SpotterTip {

    private final ImageFunction function;
    private SpotterTipLocationEffects locationEffects = null;
    private Random rand;


    public SpotterTipFunction(ImageFunction function) {
        this.function = function;
    }


    public void setLocationEffects(SpotterTipLocationEffects locationEffects) {
        this.locationEffects = locationEffects;
    }


    public Object getScaled(float pixelSize) {
        SpotterTipFunction scaled = new SpotterTipFunction(function);

        if (locationEffects != null) {
            scaled.setLocationEffects((SpotterTipLocationEffects)
                    locationEffects.getScaled(pixelSize));
        }

        return scaled;
    }


    public SpotterTipContact getSpotterTipContact(Point2D featureCellCenter,
            float featureSize) {
        ParameterBlock pb = new ParameterBlock();
        pb.add(function);
        pb.add((int)featureSize);
        pb.add((int)featureSize);
        RenderedOp rop = JAI.create("ImageFunction", pb);

        // **** need to re-center image
        return null;
    }

}
