package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.awt.image.DataBuffer;
import java.awt.image.RenderedImage;
import java.awt.image.renderable.ParameterBlock;

import javax.media.jai.JAI;

public class Tiffer {

    static public void saveTemp(RenderedImage ti, String stem) {
        saveTemp(ti, stem, 255f, 0);

    }

    static public void saveTemp(RenderedImage ti, String stem,
           float multiple, int band) {
       ParameterBlock pb;
       RenderedImage rim;
       pb = new ParameterBlock();
       pb.addSource(ti);
       pb.add( new double[] {(double)multiple} );
       rim = JAI.create("Rescale", pb);

       pb = new ParameterBlock();
       pb.addSource(rim);
       pb.add(DataBuffer.TYPE_BYTE);
       rim = JAI.create("Format", pb);

       pb = new ParameterBlock();
       pb.addSource(rim);
       pb.add(new int[] {band});
       rim = JAI.create("BandSelect", pb);
  
       pb = new ParameterBlock();
       pb.addSource(rim);
       pb.add(stem + ".tif");
       pb.add("tiff");
       pb.add(null);
       rim = JAI.create("FileStore", pb);
    }

}
