package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.util.Vector;

import org.jdom.Element;
import org.jdom.filter.Filter;

/**
 *  Encapsulate the selection of appropriate child elements in XML parsing.
 */
public class XMLChildFilter implements Filter {
    private String[] matchLabels;

    public XMLChildFilter(String[] parseLabels, boolean allowExternalData,
            boolean allowBackwardRef) {
        Vector vec = new Vector();
        for (int i=0; i<parseLabels.length; ++i) {
            addMatchLabels(vec, parseLabels[i], allowExternalData,
                    allowBackwardRef);
        }
        matchLabels = (String[])vec.toArray(new String[vec.size()]);
    }

   
    public XMLChildFilter(String parseLabel, boolean allowExternalData,
            boolean allowBackwardRef) {
        Vector vec = new Vector();
        addMatchLabels(vec, parseLabel, allowExternalData, allowBackwardRef);

        matchLabels = (String[])vec.toArray(new String[vec.size()]);
    }


    private void addMatchLabels(Vector vec, String parseLabel,
            boolean allowExternalData, boolean allowBackwardRef) {
        vec.add(parseLabel);
        if (allowExternalData) {
            vec.add(XMLAltData.getAltLabel(true, parseLabel));
        }
        if (allowBackwardRef) {
            vec.add(XMLAltData.getAltLabel(false, parseLabel));
        }
    }


    public boolean matches(Object obj) {
        if (!(obj instanceof Element))
            return false;

        String elemName = ((Element)obj).getName();
        for (int i=0; i<matchLabels.length; ++i) {
            if (matchLabels[i].equals(elemName))
                return true;
        }
        return false;
    }


    public String labelList() {
        StringBuffer sb = new StringBuffer("");
        for (int i=0; i<matchLabels.length; ++i) {
            sb.append(matchLabels[i]);
            if (i<matchLabels.length-1) {
                sb.append(",");
            }
        }
        return sb.toString();
    }

}
