package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.io.File;
import java.io.IOException;
import org.jdom.*;
import org.jdom.filter.ContentFilter;
import org.jdom.filter.Filter;
import org.jdom.input.SAXBuilder;
import java.util.Vector;
import java.util.List;
import java.util.Iterator;


public class XMLInspector {

    private static Filter commentFilter =
            new ContentFilter(ContentFilter.COMMENT);
    private static Filter extFilter = new Filter()
        {
            public boolean matches(Object obj) {
                if (!(obj instanceof Element)) {
                    return false;
                }
        
                String elemName = ((Element)obj).getName();
                return elemName.startsWith("ext_");
            }
        };


    static public void main(String[] args) {
        File file = new File(args[0]);
        String com = getDocComment(file);
        System.out.print("com=");
        System.out.println(com);
    }


    static public Document getDocument(File xmlFile)
            throws org.jdom.JDOMException, java.io.IOException {
        return new SAXBuilder().build(xmlFile);
    }


    static public String getDocComment(File xmlFile) {
        try {
            Document doc = getDocument(xmlFile);
            return getComment(doc);
        }
        catch (Exception e) {
            return null;
        }
    }


    static public String getComment(Document doc) {
        try {
            List cont = doc.getContent(commentFilter);
            Comment docComment = (Comment)cont.get(0);
            return docComment.getText().trim();
        }
        catch (Exception e) {
            return null;
        }
    }


    static String[] externalKeys(Document doc) {
        Iterator iter = doc.getDescendants(extFilter);
        Vector keys = new Vector();
        while (iter.hasNext()) {
            Element elem = (Element)iter.next();
            keys.add(elem.getAttributeValue("key"));
        }
        return (String[])keys.toArray(new String[keys.size()]);
    }

}

