package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import org.jdom.Element;

/**
 *  Exception for when alternate data (external or backward cached) is
 *  missing.
 */
public class XMLMissingAltData extends XMLParseException {

    public XMLMissingAltData(boolean isExt, Element context, String tag) {
        super(formatMsg(isExt, tag), context);
    }

    static private String formatMsg(boolean isExt, String tag) {
        return "Missing " + (isExt ? "external" : "cached") + " data: " +
                (isExt ? "key" : "id") + "\"" + tag + "\"";
    }

}
