package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import org.jdom.Element;
import org.jdom.Parent;

/**
 *  Exception for errors in parsing XML.
 */
public class XMLParseException extends Exception {

    public final Element context;


    public XMLParseException(String msg, Element context) {
        this(msg, context, null);
    }


    public XMLParseException(String msg, Element context, Throwable cause) {
        super(msg, cause);
        this.context = context;
    }


    public String formatContext() {
        if (context == null) {
            return "Context lost";
        }
        StringBuffer sb = new StringBuffer(context.getName());
        Parent parent = context.getParent();
        while (parent != null && parent instanceof Element) {
            sb.insert(0, ":");
            sb.insert(0, ((Element)parent).getName());
            parent = parent.getParent();
        }
        return sb.toString();
    }


    public String toString() {
        return super.toString() + " @ " + formatContext();
    }

}
