package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
/**
 *  Exception for when an unhandled data type occurs in the parameters for
 *  JAI operation.
 */
public class XMLUnhandledTypeException extends Exception {

    public final String typeName;
    
    public XMLUnhandledTypeException(Class type) {
        super("XML unhandled type " + type.getName());
        this.typeName = type.getName();
    }

    public XMLUnhandledTypeException(String typeName) {
        super("XML unhandled type " + typeName);
        this.typeName = typeName;
    }
}
