package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import org.jdom.Element;

/**
 *  XML wrapper for AngleBias.
 */
public class X_AngleBias extends XMLHandlerStd {

    public X_AngleBias() {
        super(AngleBias.class);
    }


    public String typeDescription() {
        return "A bias in the calculation of radius in a particular " +
               "direction as applied to the position of a vertex of a " +
               "random polygon.";
    }


    public Element schemaTypedef() {
        return XMLUtils.xsdComplexType(xmlTypeName(),
                XMLUtils.xsdGrouping("sequence", new Element[] {
                        XMLUtils.xsdElement("angle", "xsd:float"),
                        XMLUtils.xsdElement("sweep", "xsd:float"),
                        XMLUtils.xsdElement("factor", "xsd:float") }
                ));
    }


    public Object parseElement(Element elem, XMLAltData altData)
            throws XMLParseException {
        return new AngleBias(
                XMLUtils.getChildFloat(elem, "angle"),
                XMLUtils.getChildFloat(elem, "sweep"),
                XMLUtils.getChildFloat(elem, "factor") );
    }

}
