package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import javax.media.jai.InterpolationBilinear;
import javax.media.jai.operator.AddConstDescriptor;
import javax.media.jai.operator.AddDescriptor;
import javax.media.jai.operator.BandCombineDescriptor;
import javax.media.jai.operator.BandSelectDescriptor;
import javax.media.jai.operator.ClampDescriptor;
import javax.media.jai.operator.ConstantDescriptor;
import javax.media.jai.operator.CropDescriptor;
import javax.media.jai.operator.FormatDescriptor;
import javax.media.jai.operator.ImageFunctionDescriptor;
import javax.media.jai.operator.InvertDescriptor;
import javax.media.jai.operator.MaxDescriptor;
import javax.media.jai.operator.MinDescriptor;
import javax.media.jai.operator.MultiplyConstDescriptor;
import javax.media.jai.operator.MultiplyDescriptor;
import javax.media.jai.operator.OverlayDescriptor;
import javax.media.jai.operator.PatternDescriptor;
import javax.media.jai.operator.PeriodicShiftDescriptor;
import javax.media.jai.operator.RescaleDescriptor;
import javax.media.jai.operator.RotateDescriptor;
import javax.media.jai.operator.SubtractConstDescriptor;
import javax.media.jai.operator.ThresholdDescriptor;
import javax.media.jai.operator.TranslateDescriptor;

/**
 *  Class to initialize various data types and JAI operations.
 */
public class X_Builtins {

    static public void miscInit() {
        ZoneFeaturesImageOpDesc.init();
        Constant2OpDesc.init();
        Constant3OpDesc.init();
        FirstNonzeroOpDesc.init();
        ImageFunction2OpDesc.init();
        DirtOpDesc.init();
        ConvertToFloatOpDesc.init();
        PointModifyFunctionOpDesc.init();
        TiltOpDesc.init();
    }


    static public void instantiateBuiltinHandlers() 
            throws XMLUnhandledTypeException {
        new X_AngleBias();
        new X_BorderExtender();
        new X_CircleFeatureShapeFactory();
        new X_FeatureTextureDonut();
        new X_FeatureCharacteristics();
        new X_FeaturesIntensitiesImpl();
        new X_FeaturesSpecs();
        new X_FeatureTextureConst();
        new X_FeatureTextureFunction();
        new X_File();
        new X_FImageLayout();
        new X_FloatTiff();
        // new X_GNoiseFunction();
        new X_GradientFunction();
        new X_GrayscaleTiffs();
        new X_GridFeaturesIntensities();
        new X_GridMaLayout();
        new X_IFunctionFromName();
        new X_IntensitiesFileReader();
        new X_Jpeg();
        new X_MaDimensions();
        new X_NumberOfChannels();
        new X_Packed2ZonesMaLayout();
        new X_PolynomialNoiseFunction();
        new X_PolynomialNoiseTerm();
        new X_PendingRenderedOp();
        new X_Properties();
        new X_Random();
        new X_RawIntensitiesData();
        new X_RawIntensitiesRecord();
        new X_RenderedImage();
        new X_RImageFileLibrary();
        new X_Scan();
        new X_Scanner();
        new X_SpotterTipConst();
        new X_SpotterTipFunction();
        new X_SpotterTipLocationEffects();
        new X_SquareFeatureShapeFactory();
        new X_ZoneCharacteristics();
        new X_ZonesInfoImpl();
    }


    static public void registerBuiltinOperations()
            throws XMLUnhandledTypeException {
        X_OperationJAI op;

        op = new X_OperationJAI(new AddConstDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new AddDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new BandCombineDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new BandSelectDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new ClampDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new ConstantDescriptor());
        X_PendingRenderedOp.registerOperation(op);

        op = new X_OperationJAI(new Constant2OpDesc());
        X_PendingRenderedOp.registerOperation(op);

        op = new X_OperationJAI(new Constant3OpDesc());
        op.setAllowExternalData("intensity", true);
        X_PendingRenderedOp.registerOperation(op);

        op = new X_OperationJAI(new ConvertToFloatOpDesc());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new CropDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new DirtOpDesc());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new FirstNonzeroOpDesc());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new FeaturesImageOpDesc());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new FormatDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new GBlurOpDesc());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new ImageFunction2OpDesc());
        X_PendingRenderedOp.registerOperation(op);

        op = new X_OperationJAI(new ImageFunctionDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new InvertDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new MaxDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new MinDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new MultiplyDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new MultiplyConstDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new OverlayDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new PatternDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new PeriodicShiftDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new PointModifyFunctionOpDesc());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new RescaleDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new RotateDescriptor());
        op.setDefaultValue("interpolation", new InterpolationBilinear());
        op.setHide("interpolation", true);
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new SubtractConstDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new TiltOpDesc());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new ThresholdDescriptor());
        X_PendingRenderedOp.registerOperation(op);
    
        op = new X_OperationJAI(new TranslateDescriptor());
        op.setDefaultValue("interpolation", new InterpolationBilinear());
        op.setHide("interpolation", true);
        X_PendingRenderedOp.registerOperation(op);
        X_PendingRenderedOp.registerOperation(op);
    }
}
