package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.io.File;

import org.jdom.Element;
import org.jdom.filter.ElementFilter;

/**
 *  XML wrapper for CommonScanSaveParams.
 */
public class X_CommonScanSaveParams {

    static public CommonScanSaveParams parseCommonParams(Element elem,
            String defaultExtension, XMLAltData altData)
            throws XMLParseException, XMLUnhandledTypeException {

        String fnameSuffix = elem.getChildTextTrim("filenameSuffix");
        String fnameExtension = elem.getChildTextTrim("filenameExtension");
        if (fnameExtension == null) {
            fnameExtension = defaultExtension;
        }

        File outputDir = (File)
                XMLHandler.getHandler(File.class).parseChildren(elem, 
                        new ElementFilter("outputDirectory"), altData, false);

        return (outputDir == null) ?
                new CommonScanSaveParams(fnameSuffix, fnameExtension) :
                new CommonScanSaveParams(fnameSuffix, fnameExtension,
                        outputDir);
    }

    
    static public void addSchemaCommonParams(Element seqElem,
            String defaultExtension) throws XMLUnhandledTypeException {
        seqElem.addContent(XMLUtils.xsdElement("filenameSuffix", "xsd:string",
                false));

        Element fnElem = XMLUtils.xsdElement("filenameExtension", "xsd:string",
                false);
        fnElem.setAttribute("default", defaultExtension);
        seqElem.addContent(fnElem);

        seqElem.addContent(XMLHandler.getHandler(File.class).schemaInContext(
                "outputDirectory", false, false));
    }

}
