package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.awt.image.RenderedImage;

import org.jdom.Element;

/**
 *  XML wrapper for FeatureTextureConst.
 */
public class X_FeatureTextureConst extends XMLHandlerStd {

    public X_FeatureTextureConst()  throws XMLUnhandledTypeException {
        super(FeatureTextureConst.class);
    }


    public String typeDescription() {

        String shortName = handledClass.getName();
        int dotPos = shortName.lastIndexOf(".");
        if (dotPos >= 0) {
            shortName = shortName.substring(dotPos+1);
        }
        return shortName + 
         " is an implementation of " +
                "FeatureTexture that is based upon a constant image, " +
                "usually read from an image file.";
    }


    private XMLChildFilter imageFilter = null;


    /**
     * Produces an 'xsd:element' component of an XML schema for the 
     * FeatureTextureConst.  Note this is not a typedef.
     *
     * @return jdom data structure, rooted with an Element object
     */
    public Element schemaTypedef() throws XMLUnhandledTypeException {
        return XMLUtils.xsdComplexType(xmlTypeName(), 
                XMLUtils.xsdGrouping("sequence", new Element[] {
                  getHandler(RenderedImage.class).schemaInContext(
                    "image", false, true) } ) );
    }


    /**
     * Given a jdom Element object (with children), construct a
     * FeatureTextureConst instance.
     *
     * @param elem  jdom element describing the object to be instantiated.
     * @return  the instantiated FeatureTextureConst object
     */
    public Object parseElement(Element elem, XMLAltData altData)
            throws XMLParseException, XMLUnhandledTypeException {

        if (imageFilter == null) {
            imageFilter = getHandler(RenderedImage.class).getXMLChildFilter(
                    "image", true);
        }
        RenderedImage image = (RenderedImage)
                getHandler(RenderedImage.class).parseChildren(elem, imageFilter,
                        altData, true);

        return new FeatureTextureConst(image);
    }

}
