package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import org.jdom.*;

public class X_FeatureTextureDonut extends XMLHandlerStd {

    public X_FeatureTextureDonut()  throws XMLUnhandledTypeException {
        super(FeatureTextureDonut.class, true);
    }


    /**
     * Produces an 'xsd:element' component of an XML schema for the 
     * FeatureTextureDonut.  Note this is not a typedef.
     *
     * @return jdom data structure, rooted with an Element object
     */
    public Element schemaTypedef() throws XMLUnhandledTypeException {
        return XMLUtils.xsdComplexType(xmlTypeName(), 
                XMLUtils.xsdGrouping("sequence", new Element[] {
                  XMLUtils.xsdElement("widthFraction", "xsd:float"),
                  XMLUtils.xsdElement("intensityRatio", "xsd:float") }));
    }


    /**
     * Given a jdom Element object (with children), construct a FeatureTextureDonut
     * instance.
     *
     * @param elem  jdom element describing the object to be instantiated.
     * @return  the instantiated FeatureTextureDonut object
     */
    public Object parseElement(Element elem, XMLAltData altData)
            throws XMLParseException, XMLUnhandledTypeException {

        float widthFraction = XMLUtils.getChildFloat(elem, "widthFraction");
        float intensityRatio = XMLUtils.getChildFloat(elem, "intensityRatio");

        return new FeatureTextureDonut(widthFraction, intensityRatio);
    }

}
