package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import javax.media.jai.ImageFunction;

import org.jdom.Element;

/**
 *  XML wrapper for FeatureTextureFunction.
 */
public class X_FeatureTextureFunction extends XMLHandlerStd {

    public X_FeatureTextureFunction()  throws XMLUnhandledTypeException {
        super(FeatureTextureFunction.class);
    }


    public String typeDescription() {

        String shortName = handledClass.getName();
        int dotPos = shortName.lastIndexOf(".");
        if (dotPos >= 0) {
            shortName = shortName.substring(dotPos+1);
        }
        return shortName + 
         " is an implementation of " +
                "FeatureTexture, generated from an ImageFunction.";
    }


    private XMLChildFilter imfFilter = null;


    /**
     * Produces an 'xsd:element' component of an XML schema for the 
     * FeatureTextureFunction.  Note this is not a typedef.
     *
     * @return jdom data structure, rooted with an Element object
     */
    public Element schemaTypedef() throws XMLUnhandledTypeException {
        return XMLUtils.xsdComplexType(xmlTypeName(), 
                XMLUtils.xsdGrouping("sequence", new Element[] {
                  getHandler(ImageFunction.class).schemaInContext(true, true),
                  XMLUtils.xsdElement("scale", "xsd:float", false) } ) );
    }


    /**
     * Given a jdom Element object (with children), construct a
     * FeatureTextureFunction instance.
     *
     * @param elem  jdom element describing the object to be instantiated.
     * @return  the instantiated FeatureTextureFunction object
     */
    public Object parseElement(Element elem, XMLAltData altData)
            throws XMLParseException, XMLUnhandledTypeException {

        if (imfFilter == null) {
            imfFilter = getHandler(ImageFunction.class).getXMLChildFilter(true);
        }
        ImageFunction imf = (ImageFunction)
                getHandler(ImageFunction.class).parseChildren(elem, imfFilter,
                        altData, true);

        float scale = XMLUtils.getChildFloat(elem, "scale", 1f);

        return new FeatureTextureFunction(imf, scale);
    }

}
