package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import org.jdom.Element;

/**
 *  XML wrapper for FeaturesIntensitiesImpl.
 */
public class X_FeaturesIntensitiesImpl extends XMLHandlerStd {

    public X_FeaturesIntensitiesImpl() {
        super(FeaturesIntensitiesImpl.class);
    }


    public String typeDescription() {

        String shortName = handledClass.getName();
        int dotPos = shortName.lastIndexOf(".");
        if (dotPos >= 0) {
            shortName = shortName.substring(dotPos+1);
        }
        return shortName + 
         " is a standard implmentation of " +
                "FeaturesIntensities that uses a constant multiple " +
                "dimension array of pixel values.";
    }


    private XMLChildFilter filter = null;

    /**
     *  From somewhere, we have to get the number of rows,cols.
     *  This information could be explicit or it could be inferred from
     *  the raw data.
     */
    public Element schemaTypedef() throws XMLUnhandledTypeException {
        return XMLUtils.xsdComplexType(xmlTypeName(),
                XMLUtils.xsdGrouping("sequence", new Element[] {
                  getHandler(RawIntensitiesData.class).schemaInContext(
                          "rawIntensitiesData", true, false) } ) );
    }


    public Object parseElement(Element elem, XMLAltData altData)
            throws XMLParseException, XMLUnhandledTypeException {

        if (filter == null) {
            filter = new XMLChildFilter("rawIntensitiesData", false, true);
        }
        RawIntensitiesData rawData = (RawIntensitiesData)
                getHandler(RawIntensitiesData.class).parseChildren(elem,
                        filter, altData, true);

        return new FeaturesIntensitiesImpl(rawData);
    }

}
