package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import org.jdom.Element;

/**
 *  XML wrapper for FloatTiff.
 */
public class X_FloatTiff extends XMLHandlerStd {

    public X_FloatTiff() {
        super(FloatTiff.class);
    }


    public String typeDescription() {

        String shortName = handledClass.getName();
        int dotPos = shortName.lastIndexOf(".");
        if (dotPos >= 0) {
            shortName = shortName.substring(dotPos+1);
        }
        return shortName + 
         " is an image file " +
                "format that stores all channels as floats in one file.";
    }


    public Element schemaTypedef() throws XMLUnhandledTypeException {
        Element seqElem = XMLUtils.xsd("sequence");
        X_CommonScanSaveParams.addSchemaCommonParams(seqElem,
                FloatTiff.defaultFilenameExtension);

        return XMLUtils.xsdComplexType(xmlTypeName(), seqElem);
    }


    public Object parseElement(Element elem, XMLAltData altData)
            throws XMLParseException, XMLUnhandledTypeException {

        CommonScanSaveParams commonParams =
                X_CommonScanSaveParams.parseCommonParams(elem,
                FloatTiff.defaultFilenameExtension, altData);

        return new FloatTiff(commonParams);
    }

}
