package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import org.jdom.Element;

/**
 *  XML wrapper for Jpeg.
 */
public class X_Jpeg extends XMLHandlerStd {

    public X_Jpeg() {
        super(Jpeg.class);
    }


    public String typeDescription() {

        String shortName = handledClass.getName();
        int dotPos = shortName.lastIndexOf(".");
        if (dotPos >= 0) {
            shortName = shortName.substring(dotPos+1);
        }
        return shortName + 
         " type for saving an image as a " +
                "JPEG file.";
    }


    public Element schemaTypedef() throws XMLUnhandledTypeException {
        Element resizeElem =  XMLUtils.xsdElement("resizeFactor", "xsd:float",
                false);
        resizeElem.setAttribute("default", "1");

        Element seqElem = XMLUtils.xsd("sequence");
        X_CommonScanSaveParams.addSchemaCommonParams(seqElem,
                GrayscaleTiffs.defaultFilenameExtension);
        seqElem.addContent(resizeElem);

        return XMLUtils.xsdComplexType(xmlTypeName(), seqElem);
    }


    public Object parseElement(Element elem, XMLAltData altData) 
            throws XMLParseException, XMLUnhandledTypeException {
        
        float resizeFactor = XMLUtils.getChildFloat(elem, "resizeFactor", 1f);

        CommonScanSaveParams commonParams =
                X_CommonScanSaveParams.parseCommonParams(elem,
                Jpeg.defaultFilenameExtension, altData);

        return new Jpeg(commonParams, resizeFactor);
    }

}
