package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import org.jdom.Element;

/**
 *  XML wrapper for MaDimensions.
 */
public class X_MaDimensions extends XMLHandlerStd {

    public X_MaDimensions() throws XMLUnhandledTypeException {
        super(MaDimensions.class);
    }


    public String typeDescription() {

        String shortName = handledClass.getName();
        int dotPos = shortName.lastIndexOf(".");
        if (dotPos >= 0) {
            shortName = shortName.substring(dotPos+1);
        }
        return shortName + 
         
                " is a float equivalent to the java.awt.Dimension class " +
                "that is also a SelfScaler.";
    }


    private XMLChildFilter mlFilter = null;

    public Element schemaTypedef() throws XMLUnhandledTypeException {
        return XMLUtils.xsdComplexType(xmlTypeName(),
                XMLUtils.xsdGrouping("choice", new Element[] {
                  XMLUtils.xsdGrouping("sequence", new Element[] {
                    XMLUtils.xsdElement("width", "xsd:float"),
                    XMLUtils.xsdElement("height", "xsd:float") }),
                  getHandler(MaLayout.class).schemaInContext(true, false)
                  } ) );
    }


    public Object parseElement(Element elem, XMLAltData altData)
            throws XMLParseException, XMLUnhandledTypeException {

        if (mlFilter == null) {
            mlFilter = getHandler(MaLayout.class).getXMLChildFilter(false);
        }
        MaLayout layout = (MaLayout)getHandler(MaLayout.class).parseChildren(
                elem, mlFilter, altData, false);

        if (layout != null) {
            return layout.getDimensions();
        }

        return new MaDimensions(
                XMLUtils.getChildFloat(elem, "width"),
                XMLUtils.getChildFloat(elem, "height") );
    }

}
