package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import java.util.Random;

import org.jdom.Element;

/**
 *  XML wrapper for Random.
 */
public class X_Random extends XMLHandlerStd {

    public X_Random() {
        super(Random.class);
    }


    public String typeDescription() {
        return "Standard java " + this.getClass().getName() + " class.";
    }


    public Element schemaTypedef() {
        return XMLUtils.xsdComplexType(xmlTypeName(),
                XMLUtils.xsdGrouping("sequence", new Element[] {
                  XMLUtils.xsdElement("seed", "xsd:int", false) }));
    }


    public Object parseElement(Element elem, XMLAltData altData)
            throws XMLParseException {
        String seedStr = elem.getChildText("seed");
        if (seedStr == null) {
            return new Random();
        }

        int seed = 0;
        try {
            seed = Integer.parseInt(seedStr);
        }
        catch (NumberFormatException e) {
            throw new XMLParseException("integer format error", elem, e);
        }

        return new Random(seed);
    }

}
