package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
import org.jdom.Element;

/**
 *  XML wrapper for SquareFeatureShapeFactory.
 *
 *  A flavor of FeatureShapeFactory that produces square features,
 *  including support for the variability of location, size, and shape.
 *
 */
public class X_SquareFeatureShapeFactory extends XMLHandlerStd {

    public X_SquareFeatureShapeFactory() throws XMLUnhandledTypeException {
        super(SquareFeatureShapeFactory.class);
    }


    public String typeDescription() {

        String shortName = handledClass.getName();
        int dotPos = shortName.lastIndexOf(".");
        if (dotPos >= 0) {
            shortName = shortName.substring(dotPos+1);
        }
        return shortName + 
         "is a flavor of " +
                "FeatureShapeFactory that produces square features.";
    }


    public Element schemaTypedef() throws XMLUnhandledTypeException {

        return XMLUtils.xsdComplexType(xmlTypeName(), 
                XMLUtils.xsdGrouping("sequence", new Element[] {  } ) );
    }


    public Object parseElement(Element elem, XMLAltData altData)
            throws XMLParseException, XMLUnhandledTypeException {

        SquareFeatureShapeFactory factory = new SquareFeatureShapeFactory();

        return factory;
    }

}
