package org.cybertory.MSS;

/*--------------------------------------------------------
|                   COPYRIGHT (c) 2005
|          Attotron Biotechnologies Corporation
|    Distributed under the GNU general public license:
|     http://www.fsf.org/licensing/licenses/gpl.txt
|
| Avaliable from: http://www.cybertory.org
|         Author: Bill Martin  <eco_bill@yahoo.com>
|      Funded by: NIH SBIR grant #R44 RR13645 02A2
--------------------------------------------------------*/
/**
 *  Encapsulation of characteristics of a zone: spotter tip and
 *  the {@link FeatureCharacteristics} for features within this zone.
 */
public class ZoneCharacteristics implements SelfScaler {

    public final SpotterTip tip;
    public final FeatureCharacteristics[] featureCharacteristics;
    public int zoneIndex = -1;


    public ZoneCharacteristics(
            SpotterTip tip,
            FeatureCharacteristics[] featureCharacteristics) {
        this.tip = tip;
        this.featureCharacteristics = featureCharacteristics;
    }


    public void setZoneIndex(int zoneIndex) {
        this.zoneIndex = zoneIndex;
    }


    public Object getScaled(float pixelSize) {
        ZoneCharacteristics scaled = new ZoneCharacteristics(
                (tip == null) ? null : (SpotterTip)tip.getScaled(pixelSize),
                featureCharacteristics);

        scaled.setZoneIndex(zoneIndex);
        return scaled;
    }

}
